@echo off

if "%1" == "image" goto image
if "%1" == "all" goto all
if "%1" == "boot" goto boot
if "%1" == "forth" goto all

echo.
echo Usage:
echo build forth - rebuild T3XFORTH executables (requires T3X/86)
echo build image - build T3XFORTH disk image
echo build boot  - build T3XFORTH boot disk image
echo build all   - build disk images, tools, and executable (requires T3X/86)
goto fini
echo.

:all

@echo on
tx86 s86
s86 t3xforth.s86 t3xforth.bin
tx86 tfcmp
tx86 block
tfcmp
s86 boot.s86 boot.bin
s86 t3xfortb.s86 t3xforth.tmp
tfcmp t3xforth.tmp t3xfortb.bin
del t3xforth.tmp
@echo off

if "%1" == "forth" goto fini

:image

@echo on
block -f 1 -t RESERVED_FOR_BOOT_BLOCK - t3xforth.blk
block -a -f 31 -t RESERVED_FOR_PRIMARY_IMAGE - t3xforth.blk
block -a -f 1 -t RESERVED_FOR_BOOT_BLOCK - t3xforth.blk
block -a -f 31 -t RESERVED_FOR_SECONDARY_IMAGE - t3xforth.blk
block -a -r 5 1 -t Table_of_Contents toc.fth t3xforth.blk
block -a -r 1 10 -t T3XFORTH_Core_Words t3xforth.fth t3xforth.blk
block -a -r 1 10 -t T3XFORTH_Double_Words double.fth t3xforth.blk
block -a -r 1 10 -t Meta_Compiler metacomp.fth t3xforth.blk
block -a -r 1 10 -t Decompiler decomp.fth t3xforth.blk
block -a -r 1 10 -t Screen_Editor veditor.fth t3xforth.blk
block -a -r 1 10 -t System_Utilities sysutil.fth t3xforth.blk
block -a -r 1 10 -t Misc_Stuff misc.fth t3xforth.blk
block -a -r 1 10 -t T3XFORTH_Glossary GLOSSARY t3xforth.blk
block -a -f 1010 - t3xforth.blk
@echo off

if "%1" == "image" goto fini

:boot

@echo on
block -b boot.bin t3xforth.img
block -a -b -r 1 31 t3xfortb.bin t3xforth.img
block -a -f 1 -t RESERVED_FOR_BOOT_BLOCK - t3xforth.img
block -a -f 31 -t RESERVED_FOR_SECONDARY_IMAGE - t3xforth.img
block -a -r 5 1 -t Table_of_Contents toc.fth t3xforth.img
block -a -r 1 10 -t T3XFORTH_Core_Words t3xforth.fth t3xforth.img
block -a -r 1 10 -t T3XFORTH_Double_Words double.fth t3xforth.img
block -a -r 1 10 -t Meta_Compiler metacomp.fth t3xforth.img
block -a -r 1 10 -t Decompiler decomp.fth t3xforth.img
block -a -r 1 10 -t Screen_Editor veditor.fth t3xforth.img
block -a -r 1 10 -t System_Utilities sysutil.fth t3xforth.img
block -a -r 1 10 -t Misc_Stuff misc.fth t3xforth.img
block -a -r 1 10 -t T3XFORTH_Glossary GLOSSARY t3xforth.img
block -a -f 1010 - t3xforth.img
@echo off

:fini
